-- Get Public IP Address (Simple)
function ip()
	return getHTTPString("https://api.ipify.org");
end

-- Get Advanced Information
-- This site has a limit of 150 requests per minute before it bans your IP.
function ipadv()
	local ret = newMap();
	local info = getHTTPString("http://ip-api.com/line");
	if strTok(info, "\n", 1) == "success" then
		setMap(ret, "ip", strTok(info, "\n", 14));
		setMap(ret, "isp", strTok(info, "\n", 11));
		setMap(ret, "isp_org", strTok(info, "\n", 12));
		setMap(ret, "isp_more", strTok(info, "\n", 13));
		setMap(ret, "city", strTok(info, "\n", 6));
		setMap(ret, "zip", strTok(info, "\n", 7));
		setMap(ret, "region", strTok(info, "\n", 5));
		setMap(ret, "country", strTok(info, "\n", 2));
		setMap(ret, "geo", strTok(info, "\n", 8) .. "," .. strTok(info, "\n", 9));
	end
	return ret;
end

function openPorts(resolvePID)
	local p = runProgram("netstat", "-a -n -o");
	local t = newTable(3, 1)
	setTable(t, 0, 0, "Port");
	setTable(t, 1, 0, "Protocol");
	setTable(t, 2, 0, "Process");
	local data = 0;
	print("Fetching open ports...");
	while(isProgram(p) == 1) do
		if (availableProgramOutput(p) > 0) then
			local output = reduceSpaces(ltrim(programOutput(p)));
			local prot = strTok(output, " ", 1);
			local lip = strTok(output, " " , 2);
			local dip = strTok(output, " " , 3);
			local procID = strTok(output, " " , 5);
			local port = strTok(lip, ":", 2);
			if(data == 0) then if (prot == "Proto") then data = 1; end
			else
				if resolvePID == 1 then
					addTableRow(t, port, prot, getProcessName(procID));
				else
					addTableRow(t, port, prot, procID);
				end
			end
		end
	end
	return t;
end

-- For Console
function IP()
	print("Your public IP: " .. ip());
end

function IPAdv()
	local info = ipadv();
	print("Your public IP:   " .. getMap(info, "ip"));
	print("ISP:              " .. getMap(info, "isp"));
	print("ISP Organisation: " .. getMap(info, "isp_org"));
	print("                  " .. getMap(info, "isp_more"));
	print("City:             " .. getMap(info, "city"));
	print("Zip Code:         " .. getMap(info, "zip"));
	print("Region:           " .. getMap(info, "region"));
	print("Country:          " .. getMap(info, "country"));
	print("Geo Coordinates:  " .. getMap(info, "geo"));
	freeMap(info);
end

function OpenPorts(resolve)
	local t = openPorts(resolve);
	print("List of Opened Ports:");
	printTable(t);
	freeTable(t);	
end
